Description

In a Processing algorithm with many output vector layers, if I set all to a geopackage file (like in my screenshot), only the last layer is

written inside.

I would expect to have one geopackage, with all my layers inside.

I tried to add "layername=layer1" for instance. But Processing is raising an error about invalid output path.

Associated revisions

Revision bf19eb6f - 2018-01-25 05:47 AM - Nyall Dawson

[processing] Non-filed based outputs (e.g. postgis, geopackage)

options should be available for certain model outputs and script

algorithm outputs

We do this by swapping the test for non-file based output support

from checking only the algorithm's provider to instead checking

on a parameter-by-parameter basis.

This is done in order to support models. For models, depending

on what child algorithm a model output is based off, an individual

model may or may not have support for non-file based outputs. E.g

a model may generate outputs from a native qgis alg (supporting

these outputs) AND an output from a GDAL alg (with no support

for these outputs). In this case we need to enable or disable

the ui controls for non-file based outputs on an individual

output basis.

For scripts (for now) we blindly just say all outputs support

non-file based formats. This is going to be the case most of

the time, since scripts will usually be written using PyQGIS

API. For the exceptions (e.g. scripts which call other algs

like GDAL algs) we probably should add some way for the script

to indicate whether an individual output supports this, but

for now we just say they all do.

Fixes #17949

History

#1 - 2018-01-24 09:08 PM - Nyall Dawson
- Subject changed from Only the last layer is saved if we output to the same geopackage in Processing to Allow storing multiple outputs to the same 

geopackage in Processing

- Tracker changed from Bug report to Feature request

#2 - 2018-01-25 01:49 AM - Nyall Dawson

- File multioutput.png added

Note that this is already supported for native algorithms, by choosing the "Save to Geopackage" option, where you get prompted for a layer name. See

attached screenshot.

We'd have to expose this to compatible models and scripts too.

#3 - 2018-01-25 05:47 AM - Nyall Dawson

- % Done changed from 0 to 100

- Status changed from Open to Closed

Applied in changeset commit:qgis|bf19eb6f35afafe113cf3d43950e0538992d08fa.

#4 - 2018-02-21 09:42 PM - Giovanni Manghi

- Resolution set to fixed/implemented
